/*
 * Producer/consumer program using a ring buffer (lab 5).
 *
 * NEEDSWORK
 *
 * Team members:
 *
 *      Student 1 <student1@cs.hmc.edu>
 *      Student 2 <student2@cs.hmc.edu>
 */

#include <errno.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

int     main(int argc, char *argv[]);
void *  producer(void * arg);
void *  consumer(void * arg);
void    thread_sleep(unsigned int ms);

#define BUFSLOTS        10

/*
 * Structure used to hold messages between producer and consumer.
 */
struct message {
    int value;          /* Value to be passed to consumer */
    int consumer_sleep; /* Time (in ms) for consumer to sleep */
    int line;           /* Line number in input file */
    int print_code;     /* Output code; see below */
    int quit;           /* Nonzero if consumer should exit ("value" ignored) */
};

/*
 * The ring buffer itself.
 */
static struct message   buffer[BUFSLOTS];

/*
 * NEEDSWORK
 *
 * You will need to add variables here.
 */

/*
 * NEEDSWORK
 *
 * Sample conditions and mutexes.  You will need to customize these.
 */
static pthread_cond_t   sample_condition = PTHREAD_COND_INITIALIZER;
static pthread_mutex_t  mutex;

int main(int argc, char * argv[])
{
    pthread_t           consumer_tid;
    int                 error;
    pthread_mutexattr_t attr;

    /*
     * Make sure output appears right away.
     */
    setlinebuf(stdout);

    /*
     * Create an error-checking mutex.  Unfortunately, standard
     * pthread mutexes might or might not check for errors, so it's
     * necessary to initialize them by hand using a clumsy interface.
     *
     * If you are initializing multiple mutexes, you only need to do
     * the first two "mutexattr" lines once.
     */
    pthread_mutexattr_init(&attr);
    pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_ERRORCHECK);
    pthread_mutex_init(&mutex, &attr);


    /*
     * Create a thread for the consumer.
     */
    error = pthread_create(&consumer_tid, NULL, consumer, NULL);
    if ((error != 0)) {
        fprintf(stderr, "Couldn't create consumer thread on line %d: %s\n",
          __LINE__, strerror(error));
        exit(1);;
    }

    /*
     * We will call the producer directly.  (Alternatively, we could
     * spawn a thread for the producer, but then we would have to join
     * it.)
     */
    producer(NULL);

    /*
     * The producer has terminated.  Clean up the consumer, which might
     * not have terminated yet.
     */
    error = pthread_join(consumer_tid, NULL);
    if (error != 0) {
        fprintf(stderr, "Couldn't join with consumer thread on line %d: %s\n",
          __LINE__, strerror(error));
        exit(1);;
    }
    return 0;
}

void * producer(void * arg)
{
    unsigned int        consumer_sleep; /* Space for reading in data */
    int                 line = 0;       /* Line number in input */
    int                 print_code;     /* Space for reading in data */
    unsigned int        producer_sleep; /* Space for reading in data */
    int                 value;          /* Space for reading in data */

    while (scanf("%d%u%u%d",
        &value, &producer_sleep, &consumer_sleep, &print_code)
      == 4) {
        line++;
        thread_sleep(producer_sleep);
        /*
         * NEEDSWORK
         *
         * Add code here.
         */

        /*
         * After sending values to the consumer, print what was asked.
         */
        if (print_code == 1  ||  print_code == 3)
            printf("Produced %d from input line %d\n", value, line);
    }

    /*
     * NEEDSWORK
     *
     * Add code to send a message to the consumer asking it to terminate.
     */

    return NULL;
}

void * consumer(void * arg)
{
    /*
     * To make the output match the sample output for testinput2.txt, we
     * need to make sure the producer can run ahead of us before we consume
     * the first item.  We do that by sleeping for 100 ms.
     */
    thread_sleep(100);

    /*
     * NEEDSWORK
     *
     * Write the consumer here.
     */

    return NULL;
}

void thread_sleep(unsigned int ms)
{
    struct timespec     sleep_time;

    if (ms == 0)
        return;

    /*
     * NEEDSWORK
     *
     * These assignment statements are dummies.  You will need to write
     * correct values.  Remember that tv_nsec cannot equal or exceed
     * one billion!
     *
     * This code contains a sample of how to error-check a system call.
     * You use it as a prototype for checking other system calls.  However,
     * note that the pthread system calls use a different method of
     * indicating errors (they return a nonzero error code instead of
     * -1) so for pthread functions, use the prototype error checking
     * from main().
     */
    sleep_time.tv_sec = 0;
    sleep_time.tv_nsec = 250000000;
    if (nanosleep(&sleep_time, NULL) == -1) {
        fprintf(stderr, "nanosleep failed on line %d: %s\n",
          __LINE__, strerror(errno));
        exit(1);
    }
}
